#include <errno.h>
#include <drivers/uart.h>
#include <zephyr.h>
#if defined (NRF5340_XXAA_APPLICATION)
  #define CLOCK_FEATURE_HFCLK_DIVIDE_PRESENT
  #include "nrfx_clock.h"
#endif

#include "nrf21540.h"


void main(void)
{
#if defined (NRF5340_XXAA_APPLICATION)
	nrfx_clock_divider_set(NRF_CLOCK_DOMAIN_HFCLK, NRF_CLOCK_HFCLK_DIV_1);//128MHz
#endif
	printk("test 21540\n");
	int err = nrf21540_init();
	if(err)printk("error[0]  %d\n",err);
	err = nrf21540_antenna_select(NRF21540_ANT1);
	if(err)printk("error[1]  %d\n",err);
	err = nrf21540_tx_gain_set(NRF21540_TX_GAIN_Max);
	if(err)printk("error[2]  %d\n",err);
	
	err = nrf21540_power_up();
	if(err)printk("error[3]  %d\n",err);

	bool rx=false;//rx Calculate a delay for radio reception. If set to false calculate a delay for radio transmition.
	nrf_radio_mode_t radio_mode = NRF_RADIO_MODE_BLE_1MBIT;
	#if CONFIG_HAS_HW_NRF_RADIO_BLE_CODED
		radio_mode = NRF_RADIO_MODE_BLE_LR125KBIT;
	#endif
	int delay = nrf21540_default_active_delay_calculate(rx,radio_mode);

	err = nrf21540_tx_configure(NRF21540_EXECUTE_NOW,
			nrf_radio_event_address_get(NRF_RADIO,
			NRF_RADIO_EVENT_DISABLED),NRF_RADIO_TASK_TXEN);
	if(err)printk("error[4]  %d\n",err);

	nrf21540_txrx_configuration_clear();

	err = nrf21540_rx_configure(NRF21540_EXECUTE_NOW,
			nrf_radio_event_address_get(NRF_RADIO,
						NRF_RADIO_EVENT_DISABLED),NRF_RADIO_TASK_RXEN);
	if(err)printk("error[6]  %d\n",err);

	err = nrf21540_txrx_stop();
	if(err)printk("error[7]  %d\n",err);
}
